﻿using Dapper;
using Microsoft.Data.SqlClient;
using Serilog;
using Shared.DTO;
using Shared.DTO.Envios_DGA;
using Shared.DTO.VariablesEntorno;

namespace DAL
{
    public class LogEnvioRepository
    {
        public async Task<bool> InsertarLogProcesoAsync(LogProceso log)
        {
            try
            {
                await using var connection = new SqlConnection(BdConexion.StringConnection);

                var sql = @"
                INSERT INTO dbo.DGA_LOGS_PROCESOS
                (
                    NOMBRE_PROCESO,
                    FECHA_EJECUCION
                )
                VALUES
                (
                    @NombreProceso,
                    @FechaEjecucion
                );";

                await connection.ExecuteAsync(sql, log);
                return true;
            }
            catch (Exception)
            {
                return false;
            }
        }

        public async Task<bool> InsertarLogRespuesta(List<LogMedicionEnvio> logsEnviados)
        {
            await using var connection = new SqlConnection(BdConexion.StringConnection);
            try
            {
                var sql = @"INSERT INTO DGA_LOGS_ENVIOS (
                                ESTADO_ENVIO,
                                JSON_ENVIO,
                                JSON_RESPUESTA,
                                COMPROBANTE,
                                FECHA_ENVIO,
                                ID_DGA_DATO)
                            VALUES (
                                @ESTADO_ENVIO,
                                @JSON_ENVIO,
                                @JSON_RESPUESTA,
                                @COMPROBANTE,
                                @FECHA_ENVIO,
                                @ID_DGA_DATO);";

                await connection.ExecuteAsync(sql, logsEnviados);
                return true;
            }
            catch (Exception ex)
            {
                throw new Exception($"Error al insertar logs de respuesta {ex.Message}");
            }
        }

    }
}
