﻿using System.Data;
using Dapper;
using Microsoft.Data.SqlClient;
using Shared.DTO.Envios_DGA;
using Shared.DTO.VariablesEntorno;

namespace DAL
{
    public class MedicionDGARepository
    {
        public async Task<List<DatoDGATemporal>> ObtenerMedicionesPorLoteAsync(int pageNumber, DateTime fecha)
        {
            var parameters = new DynamicParameters();
            parameters.Add("@PageNumber", pageNumber);
            parameters.Add("@FechaInicio", fecha);
            await using var connection = new SqlConnection(BdConexion.StringConnection);

            var resultado = await connection.QueryAsync<DatoDGATemporal>(
                "SP_OBTENER_LOTE_DGA_DATOS",
                parameters,
                commandType: CommandType.StoredProcedure);

            return resultado.ToList();
        }

        public async Task<bool> GuardarMedicionesEnviadasAsync(List<int> medicionesGuardadas)
        {
            await using var connection = new SqlConnection(BdConexion.StringConnection);
            try
            {
                var query = @"UPDATE DGA_DATOS SET ENVIADO = 1 WHERE ID IN @Ids";

                await connection.ExecuteAsync(query, new { Ids = medicionesGuardadas });
                return true;
            }
            catch(Exception ex) {

                throw new Exception($"Error {ex.Message}");
            }

        }
    }
}
